%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Purpose: Run trained PCG classifier and obtain classifier outputs
% Inputs:
% 1. header
% 2. recordings
% 3. trained model
%
% Outputs:
% 1. score
% 2. label
% 3. classes
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

function [score, label, classes] = team_testing_code(header, recordings, loaded_model)

classes_murmur=loaded_model.classes_murmur;
classes_outcome=loaded_model.classes_outcome;

features=get_features(header,recordings);
%paruosimas modeliui
labels=categorical;
FragIl=4000;
FragStep=2000;
KCikSk=5;
Fs=4000;
PacBeg=true;
[minfreq,maxfreq] = cwtfreqbounds(4000,Fs);
features_ex=[];
for i=1:length(recordings)
    signal=recordings{1,i};
    kp=round(length(signal)/FragStep)-3;
    wt=[];
    ent=[];
    for x=1:kp
        pra=round(1+(x-1)*FragStep);
        pbg=FragIl+(x-1)*FragStep;
        [wttt,f]=cwt(signal(pra:pbg,1),Fs,'FrequencyLimits',[minfreq maxfreq]);
        wt(:,:,x)=imresize(abs(wttt(:,1:FragIl)),[91 91]);
        ent(x,1)=entropy(wt(:,:,x));
        ent(x,2)=x;
    end
    if kp >KCikSk
       kkp=KCikSk;
    else
       kkp=kp;
    end 
    ents=sortrows(ent,1);
    ents(ents(:,1)==0,:)=[];
    mwt=wt(:,:,ents(1:kkp,2));
    if PacBeg
            features_ex=mwt;
            PacBeg=false;
        else
            [vn,vm,vl]=size(features_ex);
            features_ex(:,:,vl+1:vl+kkp)=mwt;
    end
end
Xtest(:,:,1,:)=features_ex(:,:,:);
%pabaiga
[label_tmp_murmur,score_murmur]=loaded_model.model_murmur.classify(Xtest);
label_murmur=zeros(1,length(classes_murmur));
Fscore=mean(score_murmur);
Fscore1=median(score_murmur);
score_murmur=[Fscore1(1,1),Fscore1(1,2),0];
if Fscore1 >0.5
    label_tmp_murmur='Present';
else
    label_tmp_murmur='Absent';
end
label_murmur(strmatch(label_tmp_murmur,classes_murmur))=1;


[label_tmp_outcome,score_outcome]=loaded_model.model_outcome.classify(Xtest);
label_outcome=zeros(1,length(classes_outcome));
Fscoreo=mean(score_outcome);
Fscore1o=median(score_outcome);
score_outcome=[Fscore1o(1,1),Fscore1o(1,2)];
if Fscore1o(1,1) >0.5
    label_tmp_outcome='Abnormal';
else
    label_tmp_outcome='Normal';
end
label_outcome(strmatch(label_tmp_outcome,classes_outcome))=1;

classes=[classes_murmur classes_outcome];
score=[score_murmur score_outcome];

label=[label_murmur label_outcome];

end
